package com.company.testproject.web.screens.check;

import com.company.testproject.entity.CheckField;;
import com.haulmont.bali.util.ParamsMap;
import com.haulmont.cuba.gui.ScreenBuilders;
import com.haulmont.cuba.gui.components.Action;
import com.haulmont.cuba.gui.components.Table;
import com.haulmont.cuba.gui.model.CollectionLoader;
import com.haulmont.cuba.gui.screen.*;
import com.company.testproject.entity.Check;

import javax.inject.Inject;

@UiController("testproject_Check.edit")
@UiDescriptor("check-edit.xml")
@EditedEntityContainer("checkDc")
@LoadDataBeforeShow
public class CheckEdit extends StandardEditor<Check> {
    @Inject
    private CollectionLoader<CheckField> checkFieldDl;
    @Inject
    private Table<CheckField> checkFieldTable;
    @Inject
    private ScreenBuilders screenBuilders;

    @Subscribe
    private void onBeforeShow(BeforeShowEvent event) {
        checkFieldDl.setParameter("check", getEditedEntity());
    }

    @Subscribe("checkFieldTable.create")
    private void onCheckFieldTableCreate(Action.ActionPerformedEvent event) {
        screenBuilders.editor(checkFieldTable)
                .newEntity()
                .withInitializer(checkField -> {
                    checkField.setCheck(getEditedEntity());
                })
                .build()
                .show();
    }
}