package com.company.testproject.web.screens.checklist;

import com.company.testproject.entity.Check;
import com.company.testproject.web.screens.check.CheckEdit;
import com.haulmont.cuba.gui.ScreenBuilders;
import com.haulmont.cuba.gui.components.Action;
import com.haulmont.cuba.gui.components.Table;
import com.haulmont.cuba.gui.model.CollectionContainer;
import com.haulmont.cuba.gui.model.CollectionLoader;
import com.haulmont.cuba.gui.screen.*;
import com.company.testproject.entity.CheckList;

import javax.inject.Inject;

@UiController("testproject_CheckList.edit")
@UiDescriptor("check-list-edit.xml")
@EditedEntityContainer("checkListDc")
@LoadDataBeforeShow
public class CheckListEdit extends StandardEditor<CheckList> {
    @Inject
    private CollectionLoader<Check> checkDl;
    @Inject
    private Table<Check> checkTable;
    @Inject
    private ScreenBuilders screenBuilders;
    @Inject
    private CollectionContainer<Check> checkDc;

    @Subscribe
    private void onBeforeShow(BeforeShowEvent beforeShowEvent) {
        checkDl.setParameter("checkList", getEditedEntity());
        checkDl.load();
    }

    @Subscribe("checkTable.create")
    public void onCheckTableCreate(Action.ActionPerformedEvent event) {
        screenBuilders.editor(checkTable)
                .newEntity()
                .withScreenClass(CheckEdit.class)
                .withInitializer(check -> {
                    check.setCheckList(getEditedEntity());
                })
                .withAfterCloseListener(checkEditAfterScreenCloseEvent -> checkDl.load())
                .build()
                .show();
    }

    @Subscribe("checkTable.edit")
    private void onCheckTableEdit(Action.ActionPerformedEvent event) {
        screenBuilders.editor(checkTable)
                .editEntity(checkDc.getItem())
                .withScreenClass(CheckEdit.class)
                .withAfterCloseListener(checkEditAfterScreenCloseEvent -> checkDl.load())
                .build()
                .show();
    }

}